searchNodes=[{"doc":"","ref":"poolgirl.html","title":"poolgirl","type":"module"},{"doc":"This function exists for compatibility with poolboy only","ref":"poolgirl.html#checkin/2","title":"poolgirl.checkin/2","type":"function"},{"doc":"Fetch a worker from a pool","ref":"poolgirl.html#checkout/1","title":"poolgirl.checkout/1","type":"function"},{"doc":"The same as child_spec/3 with no configuration options","ref":"poolgirl.html#child_spec/2","title":"poolgirl.child_spec/2","type":"function"},{"doc":"The pool spec to use under your supervision tree","ref":"poolgirl.html#child_spec/3","title":"poolgirl.child_spec/3","type":"function"},{"doc":"List your pool's workers","ref":"poolgirl.html#get_workers/1","title":"poolgirl.get_workers/1","type":"function"},{"doc":"Change your pool's size","ref":"poolgirl.html#spin/3","title":"poolgirl.spin/3","type":"function"},{"doc":"Fetch the status of a pool","ref":"poolgirl.html#status/1","title":"poolgirl.status/1","type":"function"},{"doc":"Kill your pool","ref":"poolgirl.html#stop/1","title":"poolgirl.stop/1","type":"function"},{"doc":"Execute your function in the context of a pool worker","ref":"poolgirl.html#transaction/2","title":"poolgirl.transaction/2","type":"function"},{"doc":"","ref":"poolgirl.html#t:pool/0","title":"poolgirl.pool/0","type":"type"},{"doc":"","ref":"poolgirl.html#t:start_ret/0","title":"poolgirl.start_ret/0","type":"type"},{"doc":"","ref":"poolgirl_worker.html","title":"poolgirl_worker","type":"behaviour"},{"doc":"","ref":"poolgirl_worker.html#c:start_link/1","title":"poolgirl_worker.start_link/1","type":"callback"},{"doc":"Poolgirl is a lightweight , generic pooling library for Erlang with a focus on simplicity , performance , and rock-solid disaster recovery. Poolgirl is Poolboy's little sister, it's directed towards the use-case of simple workers that process requests with no need for a reply (ie. that only handle cast requests)","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"1&gt; Worker = poolgirl:checkout(PoolName). &lt;0.9001.0&gt; 2&gt; gen_server:call(Worker, Request). ok Q: Is this in any way related with poolboy? A: Yes, the interface and configuration is mostly the same, however poolgirl adds some additional methods. Q: So what's the difference, why another worker pool manager? A: Poolboy's manager of workers is a single gen_server process, in pools with a large number of workers the manager itself can become a bottleneck, a possible solution is to have multiple managers and load balance these. In use-case scenarios where the pool workers only handle cast requests and have a fast execution time per request (eg. analytics reporting, stats reporting) poolgirl overcomes this issue and lets you have high worker numbers with no additional overhead. Q: How does it work under the hood? A: When a client requests a worker from the pool no messages are sent to any other process in order to accomplish this, poolgirl accesses a pg2 process group and recruits a random worker. Q: But won't that overload the workers message queue? You're basically choosing a worker at random. A: That is true, hence the fact the poolgirl is best suited to the use-case described above, if you're making long synchronous requests to workers then you're probably better off sticking with poolboy. Q: So if it's the client that recruits the worker what does the checkin operation do? A: Nothing, it's there basically to ease the transition between poolboy &lt;-&gt; poolgirl","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"checkout/1 : recruits a worker from the requested pool checkin/1 : does nothing transaction/2 : recruits a worker from the requested pool and executes a funcion with the worker pid as argument get_workers/1 : returns a list of worker pids status/1 : returns the pool status spin/3 : spins up/down pool workers, these are immediately added/removed from the worker pool","ref":"readme.html#api","title":"Overview - API","type":"extras"},{"doc":"This is an example application showcasing database connection pools using Poolgirl and epgsql . example.app { application , example , [ { description , &quot;An example application&quot; } , { vsn , &quot;0.1&quot; } , { applications , [ kernel , stdlib , sasl , crypto , ssl ] } , { modules , [ example , example_worker ] } , { registered , [ example ] } , { mod , { example , [ ] } } , { env , [ { pools , [ { pool1 , [ { size , 10 } ] , [ { hostname , &quot;127.0.0.1&quot; } , { database , &quot;db1&quot; } , { username , &quot;db1&quot; } , { password , &quot;abc123&quot; } ] } , { pool2 , [ { size , 5 } ] , [ { hostname , &quot;127.0.0.1&quot; } , { database , &quot;db2&quot; } , { username , &quot;db2&quot; } , { password , &quot;abc123&quot; } ] } ] } ] } ] } . example.erl - module ( example ) . - behaviour ( application ) . - behaviour ( supervisor ) . - export ( [ start / 0 , stop / 0 , squery / 2 , equery / 3 ] ) . - export ( [ start / 2 , stop / 1 ] ) . - export ( [ init / 1 ] ) . start ( ) -&gt; application : start ( ? MODULE ) . stop ( ) -&gt; application : stop ( ? MODULE ) . start ( _ Type , _ Args ) -&gt; supervisor : start_link ( { local , example_sup } , ? MODULE , [ ] ) . stop ( _ State ) -&gt; ok . init ( [ ] ) -&gt; { ok , Pools } = application : get_env ( example , pools ) , PoolSpecs = lists : map ( fun ( { Name , SizeArgs , WorkerArgs } ) -&gt; PoolArgs = [ { name , { local , Name } } , { worker_module , example_worker } ] ++ SizeArgs , poolgirl : child_spec ( Name , PoolArgs , WorkerArgs ) end , Pools ) , { ok , { { one_for_one , 10 , 10 } , PoolSpecs } } . squery ( PoolName , Sql ) -&gt; poolgirl : transaction ( PoolName , fun ( Worker ) -&gt; gen_server : call ( Worker , { squery , Sql } ) end ) . equery ( PoolName , Stmt , Params ) -&gt; poolgirl : transaction ( PoolName , fun ( Worker ) -&gt; gen_server : call ( Worker , { equery , Stmt , Params } ) end ) . example_worker.erl - module ( example_worker ) . - behaviour ( gen_server ) . - behaviour ( poolgirl_worker ) . - export ( [ start_link / 1 ] ) . - export ( [ init / 1 , handle_call / 3 , handle_cast / 2 , handle_info / 2 , terminate / 2 , code_change / 3 ] ) . - record ( state , { conn } ) . start_link ( Args ) -&gt; gen_server : start_link ( ? MODULE , Args , [ ] ) . init ( Args ) -&gt; process_flag ( trap_exit , true ) , Hostname = proplists : get_value ( hostname , Args ) , Database = proplists : get_value ( database , Args ) , Username = proplists : get_value ( username , Args ) , Password = proplists : get_value ( password , Args ) , { ok , Conn } = epgsql : connect ( Hostname , Username , Password , [ { database , Database } ] ) , { ok , # state { conn = Conn } } . handle_call ( { squery , Sql } , _ From , # state { conn = Conn } = State ) -&gt; { reply , epgsql : squery ( Conn , Sql ) , State } ; handle_call ( { equery , Stmt , Params } , _ From , # state { conn = Conn } = State ) -&gt; { reply , epgsql : equery ( Conn , Stmt , Params ) , State } ; handle_call ( _ Request , _ From , State ) -&gt; { reply , ok , State } . handle_cast ( _ Msg , State ) -&gt; { noreply , State } . handle_info ( _ Info , State ) -&gt; { noreply , State } . terminate ( _ Reason , # state { conn = Conn } ) -&gt; ok = epgsql : close ( Conn ) , ok . code_change ( _ OldVsn , State , _ Extra ) -&gt; { ok , State } .","ref":"readme.html#example","title":"Overview - Example","type":"extras"},{"doc":"name : the pool name worker_module : the module that represents the workers size : maximum pool size","ref":"readme.html#options","title":"Overview - Options","type":"extras"},{"doc":"Luis Rascão (lrascao) luis.rascao@gmail.com","ref":"readme.html#original-author","title":"Overview - Original Author","type":"extras"},{"doc":"Poolgirl is available under the MIT license (see LICENSE ).","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added rebar3_ex_doc + make ex_doc-dry [Paulo Oliveira] Changed edoc -based doc. to ex_doc -based doc. [Paulo Oliveira]","ref":"changelog.html#2-2-1-2022-04-19","title":"Changelog - [2.2.1] - 2022-04-19","type":"extras"},{"doc":"Added rebar3_hank [Paulo Oliveira] Changed CI container approach to setup-beam with cache [Paulo Oliveira] worker initialization as to make it synchronous with the pool's [Guilherme Andrade]","ref":"changelog.html#2-2-0-2021-08-03","title":"Changelog - [2.2.0] - 2021-08-03","type":"extras"},{"doc":"Added edoc based documentation [Paulo Oliveira] a fresher approach to elvis.config [Paulo Oliveira] a fresher approach to Makefile [Paulo Oliveira] a fresher approach to rebar.config [Paulo Oliveira] Changed CI from Travis to GitHub Actions [Paulo Oliveira] Removed .editorconfig [Paulo Oliveira] bench [Paulo Oliveira] package.exs [Paulo Oliveira] VERSION [Paulo Oliveira]","ref":"changelog.html#2-1-0-2021-03-04","title":"Changelog - [2.1.0] - 2021-03-04","type":"extras"},{"doc":"Added Travis CI icon, to help increase consumer confidence Changed Travis CI targets (make it more modern) Fixed .gitignore: assume our rebar3 -oriented nature","ref":"changelog.html#2-0-3-09-09-2020","title":"Changelog - [2.0.3] - 09-09-2020","type":"extras"},{"doc":"Fixed References to locally unused functions (xref'ed)","ref":"changelog.html#2-0-2-26-09-2019","title":"Changelog - [2.0.2] - 26-09-2019","type":"extras"},{"doc":"Fixed Fix slow and unclean shutdown when using child_spec/{2,3}","ref":"changelog.html#2-0-1-23-11-2017","title":"Changelog - [2.0.1] - 23-11-2017","type":"extras"},{"doc":"Added Add benchmarks Changed Refactor process group logic Refactor supervision tree hierarchy Fixed","ref":"changelog.html#2-0-0-26-07-2016","title":"Changelog - [2.0.0] - 26-07-2016","type":"extras"},{"doc":"Added pg2 local module renamed to poolgirl_pg2","ref":"changelog.html#1-1-1-20-10-2015","title":"Changelog - [1.1.1] - 20-10-2015","type":"extras"},{"doc":"Added pg2 local module, does no global multi calls","ref":"changelog.html#1-1-0-20-10-2015","title":"Changelog - [1.1.0] - 20-10-2015","type":"extras"},{"doc":"Added README file Changed Open Source license is now MIT","ref":"changelog.html#1-0-5-04-05-2015","title":"Changelog - [1.0.5] - 04-05-2015","type":"extras"},{"doc":"Fixed Correct handling of transaction/checkout upon worker pool depletion","ref":"changelog.html#1-0-4-24-04-2015","title":"Changelog - [1.0.4] - 24-04-2015","type":"extras"},{"doc":"Added get_workers API method, returns list of worker pids","ref":"changelog.html#1-0-3-6-04-2015","title":"Changelog - [1.0.3] - 6-04-2015","type":"extras"},{"doc":"Fixed Explosive launch of worker on worker death","ref":"changelog.html#1-0-2-2-04-2015","title":"Changelog - [1.0.2] - 2-04-2015","type":"extras"},{"doc":"Changed Recruitment of local workers only","ref":"changelog.html#1-0-1-26-02-2015","title":"Changelog - [1.0.1] - 26-02-2015","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2015 Miniclip Portugal Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]